' The Japanese text in this program uses the Shift JIS code.

'****************************************
' Micro BASIC for ZCPU3 Version1.00
' Copyright (c) 2023 takami com board
'****************************************
' ̃\tgEFÁAMITCZX̂ƂŌJĂ܂BLICENSE.txtB
' This software is released under the MIT License, see LICENSE.txt.


'{۸тͤϲݼZCPU3̧ѳ(тϲBASIC)ł
'ʰ޳\
' CPU	:Z8F6421x  (  Zilog)
' RAM	:0000-0FFF ( 4Kbyte)
' ROM	:0000-FFFF (64Kbyte)
'۸ݸދK
' ZASMB!(ذ)ׂ̱ŋLq
' r0`15RAM0`15Ԓnł邱ƂOɂނe(RP=0)
' Ӱނ͎gpȂ
'([]͕ύXΏӰޭ)
' 23/06/10 ZCPU1̧ѳ(Micro BASIC for ZCPU1 Version1.02)LCD/4/EEPROM̻߰ċ@\폜AVer1.00Ƃ
'
'----------------------------------------------------------------
'No.100 ASCII CODE
'----------------------------------------------------------------
':ASCII CODE`
'@\:ASCIIނɼق蓖Ă
':
'o:
'----------------------------------------------------------------
:CH_BS	EQU	%08		'BS
:CH_LF	EQU	%0A		'LF
:CH_CR	EQU	%0D		'CR
:CH_ESC	EQU	%1B		'ESC
:CH_SP	EQU	%20		'SP
:CH_EXC	EQU	%21		'!
:CH_QUO	EQU	%22		'"
:CH_NUM	EQU	%23		'#
:CH_PER	EQU	%25		'%
:CH_AMP	EQU	%26		'&
:CH_LFT	EQU	%28		'(
:CH_RIT	EQU	%29		')
:CH_AST	EQU	%2A		'*
:CH_PLS	EQU	%2B		'+
:CH_MIN	EQU	%2D		'-
:CH_DOT	EQU	%2E		'.
:CH_SLS	EQU	%2F		'/
:CH_COL	EQU	%3A		':
:CH_SCO	EQU	%3B		';
:CH_LT	EQU	%3C		'<
:CH_EQ	EQU	%3D		'=
:CH_GT	EQU	%3E		'>
:CH_QUE	EQU	%3F		'?
:CH_CAT	EQU	%40		'@
:CH_TIL	EQU	%7E		'~
'
:CH_0	EQU	%30		'0
:CH_1	EQU	%31		'1
:CH_2	EQU	%32		'2
:CH_3	EQU	%33		'3
:CH_4	EQU	%34		'4
:CH_5	EQU	%35		'5
:CH_6	EQU	%36		'6
:CH_7	EQU	%37		'7
:CH_8	EQU	%38		'8
:CH_9	EQU	%39		'9
'
:CH_A	EQU	%41		'A
:CH_B	EQU	%42		'B
:CH_C	EQU	%43		'C
:CH_D	EQU	%44		'D
:CH_E	EQU	%45		'E
:CH_F	EQU	%46		'F
:CH_G	EQU	%47		'G
:CH_H	EQU	%48		'H
:CH_I	EQU	%49		'I
:CH_J	EQU	%4A		'J
:CH_K	EQU	%4B		'K
:CH_L	EQU	%4C		'L
:CH_M	EQU	%4D		'M
:CH_N	EQU	%4E		'N
:CH_O	EQU	%4F		'O
:CH_P	EQU	%50		'P
:CH_Q	EQU	%51		'Q
:CH_R	EQU	%52		'R
:CH_S	EQU	%53		'S
:CH_T	EQU	%54		'T
:CH_U	EQU	%55		'U
:CH_V	EQU	%56		'V
:CH_W	EQU	%57		'W
:CH_X	EQU	%58		'X
:CH_Y	EQU	%59		'Y
:CH_Z	EQU	%5A		'Z
'
:CH_SM	EQU	%6D		'm()
'----------------------------------------------------------------
'No.101 REGISTER
'----------------------------------------------------------------
':ڼ޽`
'@\:ϲ݂̊eڼ޽`(RAM)
':
'o:
'----------------------------------------------------------------
:U0TXD	EQU	%F40		'UART0 TXD	
:U0RXD	EQU	%F40		'UART0 RXD
:U0STAT0 EQU	%F41		'UART0 STAT0
:U0CTL0	EQU	%F42		'UART0 CTRL0
:U0CTL1	EQU	%F43		'UART0 CTRL1 
:U0BRH	EQU	%F46		'UARTO BAUD HIGH
:U0BRL	EQU	%F47		'UARTO BAUD LOW
'
:PAADDR	EQU	%FD0		'PORT A ADDRESS(01H:DATA DIRECTION,02H:PACTL=ALTEMATE FUNCTION)
:PACTL	EQU	%FD1		'PORT A CONTROL
:PAIN	EQU	%FD2		'PORT A INPUT DATA
:PAOUT	EQU	%FD3		'PORT A OUTPUT DATA
'
:PCADDR	EQU	%FD8		'PORT C ADDRESS(01H:DATA DIRECTION,02H:PACTL=ALTEMATE FUNCTION)
:PCCTL	EQU	%FD9		'PORT C CONTROL
:PCIN	EQU	%FDA		'PORT C INPUT DATA
:PCOUT	EQU	%FDB		'PORT C OUTPUT DATA
'
:FLAGS	EQU	%FFC		'FLAGS
:RP	EQU	%FFD		'REGISTER POINTER
:SPH	EQU	%FFE		'STK POINTER H
:SPL	EQU	%FFF		'STK POINTER L
'----------------------------------------------------------------
'No.102 WORKING AREA
'----------------------------------------------------------------
':BASICƕϐ`
'@\:BASICƕϐ`(RAM000h-0FFh)
':
'o:
'----------------------------------------------------------------
'******************************
'ܰݸڼ޽
'******************************
'%00`%0F ܰݸڼ޽r0`r15Ɏgp
'******************************
'BASIC ƕϐ
'******************************
'%10`%1F eϐ׸
:RUNF	EQU	%10		'sӰ׸(0:DIRECTӰ,1:RUNӰ)
'
:LNBIN	EQU	%12		'޲؍sԍ(1`65535)
:LNBINL	EQU	%13
'
:LNDIG	EQU	%14		'sԍ(0`5)
:LBUFZ	EQU	%15		'͍s(0`32)CR܂
'
:PC	EQU	%16		'۸Ѷ(PC)DIRECT/RUNӰނŎgp
:PCL	EQU	%17
'
:VNM	EQU	%18		'ӕϐ(ASCII) 
'
:VEA	EQU	%1A		'ӕϐڽ
:VEAL	EQU	%1B
'%20`%2F ٰ(CALC)ƕϐ(*1͓ͤ*2͏o͍ͤƕϐ)
:DLMT	EQU	%20		'I[L(*1)
:ARYF	EQU	%21		'z׸(0:ʏ̉Eʤ1:z̉E)
:PTR	EQU	%22		'߲(*1,*2)
:PTRL	EQU	%23
:LR	EQU	%24		'ڼ޽(*2)
:LRL	EQU	%25
:RR	EQU	%26		'Eڼ޽
:RRL	EQU	%27
:LR2	EQU	%28		'2ڼ޽
:LR2L	EQU	%29
:OP	EQU	%2A		'Zqڼ޽
:OP2	EQU	%2B		'2Zqڼ޽
'%30`%63 ϐ(A-Z)
:VA	EQU	%30		'ϐȀ޲(`ϐZ̉޲)
'%64`%71 ϐ(#,!,&,:,)
:XLN	EQU	%64		'ssԍ(#)
:XLNL	EQU	%65
:RLN	EQU	%66		'ݍsԍ(!)
:RLNL	EQU	%67
:EOP	EQU	%68		'۸ѐ擪߲(&)l&=264
:EOPL	EQU	%69
:EOM	EQU	%6A		'z擪߲(:)
:EOML	EQU	%6B
:MOD	EQU	%6C		'Z̗]
:MODL	EQU	%6D
:OTH	EQU	%6E		'LȊO̕ϐ(?Ȃ)
:OTHL	EQU	%6F
:TOP	EQU	%70		'۸ѐ擪߲(ϐȂ)Œl264
:TOPL	EQU	%71
'%80`%9F ͍sޯ̧(32޲)
:LBUF	EQU	%80
'%A0`%AF ͍sޯ̧(16޲)
:NBUF	EQU	%A0
'******************************
'հފJ߰
'******************************
'%D0`%DF հފJ߰
'******************************
'ر
'******************************
'%E0`%FF ر
'----------------------------------------------------------------
'No.103 OPT&VECTOR
'----------------------------------------------------------------
':߼ޯĥ޸`
'@\:
':
'o:
'----------------------------------------------------------------
	ORG	%0000		'ȍ~0Ԓn纰ޓWJ
'DBŤROMԂ؂ɐluƂ\
	DB	%EF		'߼ޯĐݒ(OSC SEL=10)
	DB	%FF
'
	DB	%00		'ؾ޸(0038Ԓnּެ)
	DB	%38
	DB	%10		'̑޸(1004Ԓnּެ)
	DB	%04
	DB	%10		'̑޸(1006Ԓnּެ)
	DB	%06
	DB	%10		'̑޸(1008Ԓnּެ)
	DB	%08
	DB	%10		'̑޸(100AԒnּެ)
	DB	%0A
	DB	%10		'̑޸(100CԒnּެ)
	DB	%0C
	DB	%10		'̑޸(100EԒnּެ)
	DB	%0E
	DB	%10		'̑޸(1010Ԓnּެ)
	DB	%10
	DB	%10		'̑޸(1012Ԓnּެ)
	DB	%12
	DB	%10		'̑޸(1014Ԓnּެ)
	DB	%14
	DB	%10		'̑޸(1016Ԓnּެ)
	DB	%16
	DB	%10		'̑޸(1018Ԓnּެ)
	DB	%18
	DB	%10		'̑޸(101AԒnּެ)
	DB	%1A
	DB	%10		'̑޸(101CԒnּެ)
	DB	%1C
	DB	%10		'̑޸(101EԒnּެ)
	DB	%1E
	DB	%10		'̑޸(1020Ԓnּެ)
	DB	%20
	DB	%10		'̑޸(1022Ԓnּެ)
	DB	%22
	DB	%10		'̑޸(1024Ԓnּެ)
	DB	%24
	DB	%10		'̑޸(1026Ԓnּެ)
	DB	%26
	DB	%10		'̑޸(1028Ԓnּެ)
	DB	%28
	DB	%10		'̑޸(102AԒnּެ)
	DB	%2A
	DB	%10		'̑޸(102CԒnּެ)
	DB	%2C
	DB	%10		'̑޸(102EԒnּެ)
	DB	%2E
	DB	%10		'̑޸(1030Ԓnּެ)
	DB	%30
	DB	%10		'̑޸(1032Ԓnּެ)
	DB	%32
	DB	%10		'̑޸(1034Ԓnּެ)
	DB	%34
	DB	%10		'̑޸(1036Ԓnּެ)
	DB	%36
'Ѻ38h`65h
	JP	:START		'Ѻ38h(56) START	(J)ѽ
	JP	:OUTCHX		'Ѻ3Bh(59) OUT1C	o͑u1o
	JP	:INPCH		'Ѻ3Eh(62) INP1C	͑u1
	JP	:CKESC		'Ѻ41h(65) CKESC	(J)ESC
	JP	:NUL		'Ѻ44h(68) (NUL)	`
	JP	:NUL		'Ѻ47h(71) (NUL)	`
	JP	:BLINK		'Ѻ4Ah(74) BLINK	LED5bԓ_ł
	JP	:T1S		'Ѻ4Dh(77) T1S	ٰ߂ɂ1bިڲ
	JP	:T100MS		'Ѻ50h(80) T100MS	ٰ߂ɂ0.1bިڲ
	JP	:NUL		'Ѻ53h(83) (NUL)	`
	JP	:NUL		'Ѻ56h(86) (NUL)	`
	JP	:NUL		'Ѻ59h(89) (NUL)	`
	JP	:NUL		'Ѻ5Ch(92) (NUL)	`
	JP	:NUL		'Ѻ5Fh(95) (NUL)	`
	JP	:NUL		'Ѻ62h(98) (NUL)	`
	JP	:NUL		'Ѻ65h(101) (NUL)	`
'----------------------------------------------------------------
'No.104 START
'----------------------------------------------------------------
':ѽ
'@\:ݒABASICN
':
'o:
'----------------------------------------------------------------
:START
    	DI			'֎~
    	SRP 	#%00		'RP=0(ܰݸڼ޽000h`00FhԒnɊ蓖Ă)
    	LDX 	:SPH,#%01	'߲ݒ(100h)
    	LDX	:SPL,#%00
	LDX	:U0BRH,#0	'BR=26(4MHẑƂ9600bps)
 	LDX	:U0BRL,#26
'PC6(LED)
	LDX	:PCADDR,#%01	'DATA DIRECTIONI
	LDX	:PCCTL,#%00	'PC6=0(OUTPUT)
	LDX	:PCADDR,#%00	'Iی
'UART1
	LDX	:PAADDR,#%02	'ALTEMATE FUNCTIONI
	LDX	:PACTL,#%30	'PA5,PA4=ALTEMATE FUNCTION(TXD0,RXD0)
	LDX	:PAADDR,#%00	'Iی
	LDX	:U0CTL0,#%C0	'MLCTSèȂ1įޯ
  	LDX	:U0CTL1,#%02
'LEDݼ޹_
	CALL	:BLINK		'LED5bԓ_
'START BASIC
:L1040
	CALL	:BASIC		'BASICs
	JR	:L1040
'----------------------------------------------------------------
'No.200 OUTCH
'----------------------------------------------------------------
':1o
'@\:[u1óAss(r0)
':oް(r0)
'o:[u
'----------------------------------------------------------------
:OUTCH
	PUSH	0
:L2000
	LDX 	r0,:U0STAT0	'TRN REG FULL?
	BTJZ	2,r0,:L2000
	POP	0
 	LDX 	:U0TXD,r0	'TRN
	RET
'----------------------------------------------------------------
'No.201 INCH
'----------------------------------------------------------------
':1
'@\:[u1́AޯȂ
':[u
'o:ް(r0)
'----------------------------------------------------------------
:INPCH
 	LDX	r0,:U0STAT0	'REC REG EMPTY?
	BTJZ	7,r0,:INPCH
	LDX	r0,:U0RXD	'REC
	RET
'----------------------------------------------------------------
'No.202 CKESC
'----------------------------------------------------------------
':ESC
'@\:[u1
':[u
'o:ESC̗͂L(C=0:ESCȂC=1:ESC)
'----------------------------------------------------------------
:CKESC
 	LDX	r0,:U0STAT0	'Mޯ̧
	BTJNZ	7,r0,:L2021
:L2020
	RCF			'C=0(ESC͂Ȃ)
	RET
:L2021
	LDX	r0,:U0RXD	'M
	CP	0,#:CH_ESC
	JR	/NE,:L2020
	SCF			'C=1(ESC͂)
	RET
'----------------------------------------------------------------
'No.205 BLINK
'----------------------------------------------------------------
':LED_
'@\:ʏ_ĂLED5bԓ_ł
':
'o:Mް(C)
'----------------------------------------------------------------
:BLINK
	LD	r0,#25		'25count
'
:L2050
	LDX	:PCOUT,#%40	'PC6(b6)=H
	CALL	:T100MS		'0.1sިڲ
'
	LDX	:PCOUT,#%00	'PC6(b6)=L
	CALL	:T100MS		'0.1sިڲ
'
	DEC	0
	JR	/NZ,:L2050
	RET
'----------------------------------------------------------------
'No.206 NUL
'----------------------------------------------------------------
':NUL(Ѻ1)
'@\:ɖ߂
':
'o:
'----------------------------------------------------------------
:NUL
	RET
'----------------------------------------------------------------
'No.220 50US
'----------------------------------------------------------------
':50s
'@\:(5+4)cycle~22(=16h)=198cycle=50us(@4MHz)
':
'o:
'----------------------------------------------------------------
:T50US
	PUSH	0
	PUSH	1
'
	LD	r0,#%00		'22(=16H)count
	LD	r1,#%16
:L2200
	DECW	0		'5cycle
	JR	/NZ,:L2200	'4cycle
'
	POP	1
	POP	0
	RET
'----------------------------------------------------------------
'No.221 T1MS
'----------------------------------------------------------------
':1ms
'@\:(5+4)cycle~444(=1BCCh)=3996clcle=999us=1ms(@4MHz)
':
'o:
'----------------------------------------------------------------
:T1MS
	PUSH	0
	PUSH	1
'
	LD	r0,#%01		'444(=01BCH)count
	LD	r1,#%BC
:L2210
	DECW	0		'5cycle
	JR	/NZ,:L2210	'4cycle
'
	POP	1
	POP	0
	RET
'----------------------------------------------------------------
'No.222 T5MS
'----------------------------------------------------------------
':5ms
'@\:(5+4)cycle~2220(=8ACh)=19980clcle=4995us=5ms(@4MHz)
':
'o:
'----------------------------------------------------------------
:T5MS
	PUSH	0
	PUSH	1
'
	LD	r0,#%08		'2220(=8ACH)count
	LD	r1,#%AC
:L2220
	DECW	0		'5cycle
	JR	/NZ,:L2220	'4cycle
'
	POP	1
	POP	0
	RET
'----------------------------------------------------------------
'No.223 T10MS
'----------------------------------------------------------------
':10ms
'@\:(5+4)cycle~4444(=115Ch)=39996clcle=9999us=10ms(@4MHz)
':
'o:
'----------------------------------------------------------------
:T10MS
	PUSH	0
	PUSH	1
'
	LD	r0,#%11		'4444(=115CH)count
	LD	r1,#%5C
:L2230
	DECW	0		'5cycle
	JR	/NZ,:L2230	'4cycle
'
	POP	1
	POP	0
	RET
'----------------------------------------------------------------
'No.224 T100MS
'----------------------------------------------------------------
':100ms
'@\:10ms~10=100ms
':
'o:
'----------------------------------------------------------------
:T100MS
	PUSH	0
'
	LD	r0,#10		'10count
:L2240
	CALL	:T10MS		'10ms
	DEC	0
	JR	/NZ,:L2240
'
	POP	0
	RET
'----------------------------------------------------------------
'No.225 T1S
'----------------------------------------------------------------
':1s
'@\:0.1s~10=1s
':
'o:
'----------------------------------------------------------------
:T1S
	PUSH	0
'
	LD	r0,#10		'10count
:L2250
	CALL	:T100MS		'100ms
	DEC	0
	JR	/NZ,:L2250
'
	POP	0
	RET
'----------------------------------------------------------------
'No.300 BASIC
'----------------------------------------------------------------
':BASIC
'@\:ϲBASICҲٰ
':
'o:
'----------------------------------------------------------------
:BASIC
:VER1	EQU	:CH_1		'BASICҼެްޮ
:VER2	EQU	:CH_0		'BASICϲŰްޮ1
:VER3	EQU	:CH_0		'BASICϲŰްޮ2
:ROMNO  EQU	:CH_3		'ROMмֳNo.
'ݒ
	LD	:TOP,#%01	'۸ѐ擪=264(Œl)
	LD	:TOPL,#%08
	LD	:EOP,#%01	'&=264(۸ѐ擪)
	LD	:EOPL,#%08
	LD	:EOM,#%08	':=2048(z擪)۸Ѵر=:-&=1784byte
	LD	:EOML,#%00
'BASICްޮݕ\"
	LD	r0,#:CH_CR	'"mBASIC x.xx /x"
	CALL	:OUTCHX
	LD	r0,#:CH_CR
	CALL	:OUTCHX
	LD	r0,#:CH_SM
	CALL	:OUTCHX
	LD	r0,#:CH_B
	CALL	:OUTCH
	LD	r0,#:CH_A
	CALL	:OUTCHX
	LD	r0,#:CH_S
	CALL	:OUTCHX
	LD	r0,#:CH_I
	CALL	:OUTCHX
	LD	r0,#:CH_C
	CALL	:OUTCHX
	LD	r0,#:CH_SP
	CALL	:OUTCHX
	LD	r0,#:VER1
	CALL	:OUTCHX
	LD	r0,#:CH_DOT
	CALL	:OUTCHX
	LD	r0,#:VER2
	CALL	:OUTCHX
	LD	r0,#:VER3
	CALL	:OUTCHX
	LD	r0,#:CH_SP
	CALL	:OUTCHX
	LD	r0,#:CH_SLS
	CALL	:OUTCHX
	LD	r0,#:ROMNO
	CALL	:OUTCHX
	LD	r0,#:CH_CR
	CALL	:OUTCHX
'OK\
:L3000
	LD 	r0,#:CH_O	'OK\
	CALL	:OUTCHX
	LD 	r0,#:CH_K
	CALL	:OUTCHX
	LD 	r0,#:CH_SP
	CALL	:OUTCHX
:L3001
	CALL	:INLINE		'1s
	CALL	:CKLINE		'sԍ(ʂLNBIN,LNGIG)
'(1)CRȂ礉Ȃ
	JP	/NC,:L3003	'CR܂͍sԍ+CR?
	CP	:LNDIG,#0
	JP	/EQ,:L3001	'߂
'(2)0+CRȂLIST
	CP	:LNBIN,#0	'sԍ0?
	JR	/NE,:L3002
	CP	:LNBINL,#0
	JR	/NE,:L3002
	CALL	:LIST		'LIST
	JP	:L3000		'߂
'(3)0ȊO̍sԍ+CRȂDELETE
:L3002
	CALL	:DELETE		'DELETE
	JP	:L3001		'߂
'(4)sԍ++CRȂWRITE
:L3003
	CP	:LNDIG,#0	'擪ɍsԍ邩?
	JR	/Z,:L3004
	CALL	:WRITE		'WRITE
	JR	:L3001		'߂
'(5)擪ɍsԍȂDIRECT(=LBUF۸тs)
:L3004
	CLR	:RUNF		'DIRECTӰނɐݒ
	CLR	:PC		'PC𕶎͍sޯ̧擪(DBUF)ɾ
	LD	:PCL,#:LBUF
	CALL	:EXEC		'CR܂۸юs
	CP	:RUNF,#0	'DIRECTӰނȂ߂RUNӰނȂRUN
	JP	/EQ,:L3000
'(6)RUN׸=1ȂRUN
:L3005
	CALL	:CKESC		'ESC?
	JR	/C,:L3000
	LDWX	0,:XLN		'sΏۍsԍ(#)
	CALL	:SRLN
	CP	0,:EOP		'۸ѐ擪(&)ƈv?
	JR	/NE,:L3006
	CP	1,:EOPL   
	JR	/NE,:L3006
	CLR	:RUNF		'۸ѐ擪(&)ɓB̂۸юsI(RUNF=0)߂
	JP	:L3000
:L3006
	LDWX	8,0		'sΏۍs̍sԍǎ
	CALL	:VALNN
	LDWX	:XLN,10
	INCW	12
	LDWX	:PC,12		'sΏۍs̖ߐ擪PC
	CALL	:EXEC		'CR܂۸юs
	JR	:L3005		'̍ss
'----------------------------------------------------------------
'No.310 INLINE
'----------------------------------------------------------------
':1s
'@\:[u1s(CR܂)Aƕϐ(r0,r1)
':[u
'o:ް(:LBUF`)CR܂ް(LBUFZ)
'----------------------------------------------------------------
:INLINE
	LD	r1,#0		'sޯ̧=0
:L3100
	CALL	:INPCH		'1
:L3109
	CALL	:OUTCHX		'ޯ
	CP	0,#:CH_BS	'BS?
	JR	/EQ,:L3101
	LD	:LBUF,r1,r0	'ޯ̧ɕۑ
	INC	r1		'ނ+1
	CP	0,#:CH_CR	'CR?
	JR	/NZ,:L3102
	LD	:LBUFZ,1	'LBUFZɍsޯ̧ްނۑ
	RET
:L3101
	CP	1,#0		'BS\?
	JR	/EQ,:L3100
	DEC	1		'ނ-1
	JR	:L3100
'31ڂCRȊOȂ32ڂICRɂ
:L3102
	CP	1,#32		'(INCO)31ڂ?
	JR	/NE,:L3100
	LD	r0,#:CH_CR	'zCRMް쐬
	JR	:L3109		'MɃWv
'----------------------------------------------------------------
'No.311 CKLINE
'----------------------------------------------------------------
':sԍ
'@\:ޯ̧̍sԍAƕϐ(r3)
':ޯ̧̐擪(LBUF`)
'o:޲ؕ\sԍ(LNBIN,LNBINL)sԍ(LNDIG)CRŏI(C=1)
'----------------------------------------------------------------
:CKLINE
	CLR	:LNBIN		'sԍ(LNBIN)
	CLR	:LNBINL
	LD	r3,#0		'sԍ(r3)
'1Ǎ㤉Z
:L3110
	LD	r0,:LBUF,r3	'1Ǎ
	CALL	:VAL1N		'1lϊ
	JR	/C,:L3111	'?(łȂΏI)
	LD	2,0		'_̍sԍ10{㤍ǂݍ1Z
	LDWX	0,:LNBIN
	CALL	:MUL10
	ADD	1,2
	ADC	0,#0
	LDWX	:LNBIN,0
'
	INC	r3		'sԍ+1
	JR	:L3110
'񐔂̏ꍇ
:L3111
	LD	:LNDIG,3	'sԍۑ
	CP	0,#:CH_CR	'I
	JR	/EQ,:L3112
	RCF			'C=0(CRŏI)
	RET
:L3112
	SCF			'C=1(CRŏI)
	RET
'----------------------------------------------------------------
'No.312 DELETE
'----------------------------------------------------------------
':1s폜
'@\:ws۸т΍폜(ۯ]߲(&)炷)Ζ
':sԍ(LNBIN)
'o:հ۸
'----------------------------------------------------------------
:DELETE
	LDWX	0,:LNBIN	'wsԍwsRR0
	CALL	:SRLN
	LDWX	12,0		'wsRR12ɂۑ(Ŏgp)
	JR	/C,:L3120	'ws(폜Ώ)݂ȂΏI
	RET
:L3120
	INCW	0		'̎̍s(CR̎)RR0
	LDX	2,@0
	CP	2,#:CH_CR
	JR	/NZ,:L3120
	INCW	0
	CP	0,:EOP		'ws(폜Ώ)ŏIs?
	JR	/NE,:L3121
	CP	1,:EOPL
	JR	/NE,:L3121
	LDWX	:EOP,12		'ŏIsȂ礖۸߲(&)̍XV݂̂ŏI
	RET
'ws(폜Ώ)ŏIsłȂ̂œ]Kv
:L3121
	LDWX	8,0		'ws̎̍s(CR̎)RR8
	LDWX	10,:EOP		'۸і(&-1)RR10
	DECW	10
	SUB	1,13		'폜޲ĐvZ(RR0-RR12)
	SBC	0,12
	SUB	:EOPL,1		'۸߲(&)폜޲Đ炷
	SBC	:EOP,0
	CALL	:BMOV		'رk(RR8`RR10RR12ۯ])
	RET
'----------------------------------------------------------------
'No.313 WRITE
'----------------------------------------------------------------
':1s
'@\:ws۸т΍폜}Α}̂
':sԍ(LNBIN,LNBINL)
'o:հ۸
'----------------------------------------------------------------
:WRITE
'sԍ΍폜
	CALL	:DELETE		'1s폜s
'KpȂ礏1s̴رg
	LDWX	0,:LNBIN	'wsԍws𒴂ŏ̍s
	CALL	:SRLN
	CP	0,:EOP		'۸ѐ擪(&)ƈv?
	JR	/NE,:L3131
	CP	1,:EOPL
	JR	/NE,:L3131
'(ݐ悪۸і̂Ƃʹر͊gȂ)
	LDWX	14,0		'ws𒴂ŏ̍sRR14(Ŏgp)
	ADD	:EOPL,:LBUFZ	'۸߲(&)}޲Đ₷
	ADC	:EOP,#0
	JR	:L3132
'(ݐ悪۸іȊOƂʹرg)
:L3131
	LDWX	10,0		'ws𒴂ŏ̍sRR10,RR14(RR14͌Ŏgp)
	LDWX	14,0
	LDWX	8,:EOP		'۸߲(&-1)RR8
	DECW	8
	ADD	:EOPL,:LBUFZ	'۸߲(&)}޲Đ₷
	ADC	:EOP,#0
	LDWX	12,:EOP		'}۸іʒu(&-1)RR12
	DECW	12
	CALL	:BMOVR		'رg(RR8`RR10RR12֋tۯ])
'g債رɍsޯ̧ް]
:L3132
	LD	r8,#0		'͍sޯ̧擪ڽRR8
	LD	r9,#:LBUF
	LD	r10,#0		'͍sޯ̧(CR܂)ڽRR10
	LD	r11,#:LBUF
	ADD	11,:LBUFZ
	DEC	11
	LDWX	12,14		'۸ѕۑRR12(ۑĂްgp)
	CALL	:BMOV		'͍sޯ̧۸Ѵر֓](RR8`RR10RR12ۯ])
	RET
'----------------------------------------------------------------
'No.314 LIST
'----------------------------------------------------------------
':LIST
'@\:۸(:`&-1)͈̔͂o
':
'o:
'----------------------------------------------------------------
:LIST
	LD	r0,#:CH_TIL	'ŏ(~)o
	CALL	:OUTCHX		'1o
	LDWX	2,:TOP		'߲=۸ѐ擪(:)
:L3140
	CP	2,:EOP		'۸ѐ擪(&)ƈv?
	JR	/NE,:L3142
	CP	3,:EOPL
	JR	/NE,:L3142	'vȂI
:L3141
	LD	r0,#:CH_TIL	'Ō(~)o
	CALL	:OUTCHX		'1o
	RET
:L3142
	CALL	:CKESC		'ESCL[?
	JR	/C,:L3141
	LDX	0,@2		'1Ǎ
	CALL	:OUTCHX		'1o
	INCW	2		'߲+1
	JR	:L3140
'----------------------------------------------------------------
'No.320 OUTCHX
'----------------------------------------------------------------
':g1o
'@\:[u1oͤCȐꍇLFtAss(r0)
':oް(r0)
'o:[u
'----------------------------------------------------------------
:OUTCHX
	CALL	:OUTCH		'OUT 1CH
	CP	0,#:CH_CR	'IF CR?
	JR	/NZ,:L3200
'
	PUSH	0
	LD	r0,#:CH_LF	'OUT LF
	CALL	:OUTCH
	POP	0
:L3200
	RET
'----------------------------------------------------------------
'No.321 OUT1N
'----------------------------------------------------------------
':1o
'@\:[u֐1o
':oް(r0)
'o:[u
'----------------------------------------------------------------
:OUT1N
	ADD	0,#%30
	CALL	:OUTCH
	RET
'----------------------------------------------------------------
'No.322 OUTNN
'----------------------------------------------------------------
':10io
'@\:2޲ް10iŒ[ɏóAR0`R1,R7`R15j
':o͑Ώ(RR0)
'o:[u
'----------------------------------------------------------------
:OUTNN
	LD	r7,#0		'ۻڽL(R7=0)
	LDWX	12,0
'10000̈ʂ̏
	LD	r10,#%27	'o͑Ώ(RR8)10000(=2710H)ŊĤʂo
	LD	r11,#%10
	CALL	:L3220
'1000̈ʂ̏
	LD	r10,#%03	'](RR12)1000(=03E8H)ŊĤʂo
	LD	r11,#%E8
	CALL	:L3220
'100̈ʂ̏
	LD	r10,#%00	'](RR12)100(=0064H)ŊĤʂo
	LD	r11,#%64
	CALL	:L3220
'10̈ʂ̏
	LD	r10,#%00	'](RR12)10(=000AH)ŊĤʂo
	LD	r11,#%0A
	CALL	:L3220
'1̈ʂ̏
	LD	0,13		'](R13)o
	CALL	:OUT1N
	RET
'O̗](RR12)w肳ꂽl(RR10)Ŋ褌ʂ[u֏o
:L3220
	LDWX	8,12		'](RR12)o͑Ώ(RR8)Ƃ
	CALL	:DIVW
	CP	15,#0		'(R15)0?
	JR	/NE,:L3221
	CP	7,#0		'ۻڽ?
	JR	/EQ,:L3222
:L3221
	LD	0,15		'Ē[u֏o
	CALL	:OUT1N
	LD	r7,#1		'ۻڽ
:L3222
	RET
'----------------------------------------------------------------
'No.330 MUL10
'----------------------------------------------------------------
':2޲10{Z
'@\:RR010{Aڼ޽ɉe^Ȃ
':ZO(RR0)
'o:Z(RR0=RR0*10)
'----------------------------------------------------------------
:MUL10
	PUSH	2
	PUSH	3
'
	LDWX	2,0		'SAVE RR0

'
	RCF			'RR0*2
	RLC	1
	RLC	0
'
	RCF			'RR0*4
	RLC	1
	RLC	0

	RCF			'RR0*8
	RLC	1
	RLC	0
'
	ADD	1,3		'RR0*8+RR0
	ADC	0,2
'
	ADD	1,3		'RR0*8+RR0+RR0
	ADC	0,2
'
	POP	3
	POP	2
	RET
'----------------------------------------------------------------
'No.331 ADDW
'----------------------------------------------------------------
':ܰމZ
'@\:ėpܰމZ
':Z(RR8)Z(RR10)
'o:Z(RR12)
'----------------------------------------------------------------
:ADDW
	LDWX	12,8
	ADD	13,11
	ADC	12,10
	RET
'----------------------------------------------------------------
'No.332 SUBW
'----------------------------------------------------------------
':ܰތZ
'@\:ėpܰތZ(A-B)
':팸Z(RR8)Z(RR10)
'o:Z(RR12)
'----------------------------------------------------------------
:SUBW
	LDWX	12,8
	SUB	13,11
	SBC	12,10
	RET
'----------------------------------------------------------------
'No.333 MULW
'----------------------------------------------------------------
':ܰޏZ
'@\:ėpܰޏZ
':Z(RR8)Z(RR10)
'o:Z(RR12)
'----------------------------------------------------------------
:MULW
	LD	14,9		'R9*R11ڼ޽ɓ]
	LD	15,11
	MULT	14
	LDWX	12,14
'
	LD	14,8		'R8*R11̉޲Ăڼ޽̏޲ĕɉZ
	LD	15,11
	MULT	14
	ADD	12,15
'
	LD	14,9		'R9*R10̉޲Ăڼ޽̏޲ĕɉZ
	LD	15,10
	MULT	14
	ADD	12,15
	RET
'----------------------------------------------------------------
'No.334 DIVW
'----------------------------------------------------------------
':ܰޏZ
'@\:ėpܰޏZ
':폜Z(RR8)Z(RR10)
'o:Z(RR14)](RR12)
'----------------------------------------------------------------
:DIVW
	CP	10,#0		'Z(RR10)=0?
	JR	/NZ,:L3340
	CP	11,#0
	JR	/Z,:L3343
:L3340
	CLR	14		'(RR14)
	CLR	15
:L3341
	CALL	:SUBW		'폜Z(RR8)-Z(RR10)
	JR	/C,:L3342	'?
	LDWX	8,12
	INCW	14		'綳+1
	JR	:L3341
:L3342
	LDWX	12,8		'1߂̂Ōɖ߂̎_ŏZ(RR14)](RR12)
	RET
:L3343
	CLR	14		'Z(RR14)=0A](RR12)=폜Z(RR8)
	CLR	15
	JR	:L3342
'----------------------------------------------------------------
'No.335 LTW,EQU,GTW
'----------------------------------------------------------------
':ܰޔr(<,=,>)
'@\:ėpܰޔr(A<B,A=B,A>B)
':A(RR8)B(RR10)
'o:r(^̂ƂRR12=1ÛƂRR12=0)
'----------------------------------------------------------------
'ܰޔr(A<B)
:LTW
	CP	8,10		'޲Ă]
	JR	/C,:L3350
	JR	/UGT,:L3351
	CP	9,11		'޲Ă]
	JR	/C,:L3350
	JR	:L3351
'ܰޔr(A>B)
:GTW
	LDWX	12,8		'RR8RR10
	LDWX	8,10
	LDWX	10,12
	JR	:LTW		'A<Br
'ܰޔr(A=B)
:EQW
	CP	8,10		'޲Ă]
	JR	/NE,:L3351	
	CP	9,11		'޲Ă]
	JR	/NE,:L3351	'A=BȊOŕ
'(^̂Ƃ)
:L3350
	CLR	12		'RR12=1
	LD	13,#1
	RET
'(ÛƂ)
:L3351
	CLR	12		'RR12=0
	CLR	13
	RET
'----------------------------------------------------------------
'No.340 BMOV
'----------------------------------------------------------------
':ۯ]
'@\:w͈͂̓]ްwڽ֤ڽ𑝉Ȃ]ARR8,RR12͕ω
':]擪ڽ(RR8)]ڽ(RR10)]擪ڽ(RR12)
'o:w͈͂RAM
'----------------------------------------------------------------
:BMOV
	PUSH	0
:L3400
	LDX	0,@8		'R0  @RR8
	LDX	@12,0		'@RR12  R0
	CP	8,10		'RR8=RR10ȂI
	JR	/NE,:L3401
	CP	9,11
	JR	/NE,:L3401
'
	POP	0
	RET
:L3401
	INCW	8		'RR8+1
	INCW	12		'RR12+1
	JR	:L3400		'߂
'----------------------------------------------------------------
'No.341 BMOVR
'----------------------------------------------------------------
':tۯ]
'@\:w͈͂̓]ްwڽ֤ڽȂ]ARR8,RR12͕ω
':]擪ڽ(RR10)]ڽ(RR8)]斖ڽ(RR12)
'o:w͈͂RAM
'----------------------------------------------------------------
:BMOVR
	PUSH	0
:L3410
	LDX	0,@8		'R0  @RR8
	LDX	@12,0		'@RR12  R0
	CP	8,10		'RR10=RR8ȂI
	JR	/NE,:L3411
	CP	9,11
	JR	/NE,:L3411
'
	POP	0
	RET
:L3411
	DECW	8		'RR8-1
	DECW	12		'RR12-1
	JR	:L3410		'߂
'----------------------------------------------------------------
'No.350 VAL1N
'----------------------------------------------------------------
':1lϊ
'@\:\̐1𐔒l
':ϊO(R0=30h`39hє)
'o:ϊ㐔l(R0=00h`09h񐔂̏ꍇR0͕s)ʂCF(0:,1:)AR0,CFȊO͕s
'----------------------------------------------------------------
:VAL1N
	CP	0,#:CH_0	'"0"`"9"?
	JR	/C,:L3500
	CP	0,#:CH_9
	JR	/UGT,:L3500
	SUB	0,#:CH_0	'l
	RCF			'CF=0()
	RET
:L3500
	SCF			'CF=1()
	RET
'----------------------------------------------------------------
'No.351 VALNN
'----------------------------------------------------------------
':Nlϊ
'@\:wڽ10i޲ؐlARR10,RR12ȊO͕sϤRR8ްsςۏ؂Ă
':wڽ(RR8)
'o:޲ؕ\l(RR10)ȊO̕߂Čꂽڽ(RR12)
'----------------------------------------------------------------
:VALNN
	PUSH	0		'R0`R2ޔ
	PUSH	1
	PUSH	2
'
	LDWX	12,8		'߲(RR12=RR8)
	CLR	10		'ϊʂl(RR10=0)
	CLR	11
:L3510
	LDX	0,@12		'1Ǎ
	CALL	:VAL1N		'?(łȂΏI)
	JR	/C,:L3511
	LD	2,0		'_̍sԍ10{㤍ǂݍ1Z(RR10=RR10*10+R2)
	LDWX	0,10
	CALL	:MUL10
	ADD	1,2
	ADC	0,#0
	LDWX	10,0
'
	INCW	12		'߲+1
	JR	:L3510
'񐔂̏ꍇ
:L3511
	POP	2		'R0`R2A
	POP	1
	POP	0
	RET
'----------------------------------------------------------------
'No.360 EXEC
'----------------------------------------------------------------
':1ss
'@\:wڽ̍sCR܂ŎsADIRECT/RUNӰނŎgp
':wڽ(PC)
'o:sӰ׸(#=RUNF=1ȊORUNF=s)
'----------------------------------------------------------------
:EXEC
'
	LDX	0,@:PC		'ӕϐۑ(VNM)
	LD	:VNM,0
	CP	0,#:CH_QUO	'ӂٸ(")?
	JP	/EQ,:L36010
	CP	0,#:CH_LFT	'ӂ͍()?
	JP	/EQ,:L3605
	CP	0,#:CH_CAT	'ӂ͔z(@)?
	JR	/EQ,:L3600
'ӂϐ̂Ƃ
	CALL	:CALVA		'ϐ(R0)̎ڽvZ(VEA)
	JR	:L3601
'ӂz(@)̂Ƃ
:L3600
	INCW	:PC		'PCӔz擪Ɉړ
	INCW	:PC
	LD	:DLMT,#:CH_RIT	'IL")"ƂĤz̒lvZ(RR0)
	LDWX	:PTR,:PC
	CALL	:CALC
	LDWX	:PC,:PTR
	LDWX	0,:LR		'z(RR0)̎ڽvZ(VEA)
	CALL	:CALAA
:L3601
	LDWX	:VEA,2
	INCW	:PC		'PCEӐ擪Ɉړ
	INCW	:PC
'EӂvZ
	LD	:DLMT,#:CH_CR	'ILCRƂĤEӒlvZ(RR0)
	LDWX	:PTR,:PC
	CALL	:CALC
	LDWX	:PC,:PTR
'O(ӕϐ"#"̂Ƃ)
	CP	:VNM,#:CH_NUM	'U(#=0)Ȃ礑𽷯
	JR	/NE,:L3603
	CP	:LR,#0
	JR	/NE,:L3602
	CP	:LRL,#0
	JR	/NE,:L3602
	JR	:L3605
:L3602
	LDWX	:RLN,:XLN	'ϐ(!)݂̍sԍ+1(#+1)ɾ
	INCW	:RLN
	LDWX	:XLN,:LR	'ϐ(#)XV
	LD	:RUNF,#1	'RUNF=1(۸юsӰ)
	RET
'Eӂӂɑ
:L3603
	LDX	@:VEA,:LR	'EӒl(=ڼ޽)ӕϐɑ
	INCW	:VEA
	LDX	@:VEA,:LRL
	DECW	:VEA
'O(ӕϐ"?"̂Ƃ)
	CP	:VNM,#:CH_QUE	'ӕϐ"?"?
	JR	/NE,:L3606
	LDWX	0,:LR		'EӒl10io
	CALL	:OUTNN
	DECW	:PC
:L3604
	LDX	0,@:PC		's菈
	CP	0,#:CH_SCO
	JR	/EQ,:L3605
	LD	r0,#:CH_CR
	CALL	:OUTCHX
'I
:L3605
	INCW	:XLN		'̍sԍ+1Ă߂
	RET
'O(ӕϐ">"̂Ƃ)
:L3606
	CP	:VNM,#:CH_GT	'ӕϐ">"?
	JR	/NE,:L3605
	LD	0,:MODL		'ϐ%̉޲ār0
	LD	1,:MOD		'ϐ%̏޲ār1
	CALL	@:LR		'Eӂ̒lڽƂ@Bٰ݂
	LD	:MODL,0		'r0ϐ%̉޲
	LD	:MOD,1		'r1ϐ%̏޲
	JR	:L3605
'ӕϐٸ(o)̂Ƃ
:L36010
	INCW	:PC		'ٸ(")܂ł̕o
	LDX	0,@:PC
	CP	0,#:CH_QUO
	JR	/EQ,:L36011
	CALL	:OUTCHX
	JR	:L36010
:L36011
	INCW	:PC		'ٸ(")̎к(;)Ȃs𽷯
	JR	:L3604		's菈
'----------------------------------------------------------------
'No.361 CALC
'----------------------------------------------------------------
':vZ
'@\:vZ̒lԂADIRECT/RUNӰނŎgp
':̐擪Ԓn(:PTR)̏IL(:DLMT)
'o:IL̔Ԓn(:PTR)̒l(:LR)
'----------------------------------------------------------------
:CALC
'ƕϐ
	CLR	:LR		'ڼ޽(LR=0)
	CLR	:LRL
	CLR	:RR		'Eڼ޽(RR=0)
	CLR	:RRL
	LD	:OP,#:CH_PLS	'Zq(OP="+")
	CLR	:ARYF		'z׸ޏ(ARYF=0)
	JR	:L3611		'ŏ߲XV𽷯
'߲XV1Ǎ
:L3610
	INCW	:PTR		'߲XV
:L3611
	LDX	0,@:PTR		'1Ǎ
'(؋L)
	CP	0,:DLMT		'؋L
	JP	/EQ,:L36110
'()
	CP	0,#:CH_0	'"0"`"9"
	JP	/C,:L3612
	CP	0,#:CH_9
	JP	/ULE,:L36120
'(ʕϐ)
:L3612
	CP	0,#:CH_A	'"A"`"Z"
	JP	/C,:L3613
	CP	0,#:CH_Z
	JP	/ULE,:L36130
'(ϐ)
:L3613
	CP	0,#:CH_NUM	'"#"(ssԍ)
	JP	/EQ,:L36130
	CP	0,#:CH_EXC	'"!"(ݍsԍ)
	JP	/EQ,:L36130
	CP	0,#:CH_PER	'"%"(])
	JP	/EQ,:L36130
	CP	0,#:CH_AMP	'"&"(۸Ѵر擪Ԓn)
	JP	/EQ,:L36130
	CP	0,#:CH_COL	'":"(zر擪Ԓn)
	JP	/EQ,:L36130
'(ZpZq)
	CP	0,#:CH_PLS	'"+"
	JP	/EQ,:L36140
	CP	0,#:CH_MIN	'"-"
 	JP	/EQ,:L36140
	CP	0,#:CH_AST	'"*"
	JP	/EQ,:L36140
	CP	0,#:CH_SLS	'"/"
	JP	/EQ,:L36140
	CP	0,#:CH_LT	'"<"
	JP	/EQ,:L36140
	CP	0,#:CH_EQ	'"="
	JP	/EQ,:L36140
	CP	0,#:CH_GT	'">"
	JP	/EQ,:L36140
'(̑)
	CP	0,#:CH_LFT	'"("
	JP	/EQ,:L36150
	CP	0,#:CH_RIT	'")"
	JP	/EQ,:L36160
	CP	0,#:CH_CAT	'"@"
	JP	/EQ,:L36170
	CP	0,#:CH_QUE	'"?"
	JP	/EQ,:L36180
	JP	:L36190		'̑
'؂L̂Ƃ
:L36110
	CALL	:L361Z0		'LR=LR op RR
	RET			'vZٰݏI(ʂLR)
'"0"`"9"̂Ƃ
:L36120
	CALL	:VAL1N		'𐔒l
	LD	2,0
	LDWX	0,:RR		'10{
	CALL	:MUL10
	ADD	1,2		'lZ
	ADC	0,#0
	LDWX	:RR,0
	JP	:L3610		'̕
'ϐ"A"`"Z","#","!","%","&":"̂Ƃ
:L36130
	CALL	:CALVA		'ϐڽvZ(ʂRR2)
	LDX	:RR,@2
	INCW	2
	LDX	:RRL,@2
	JP	:L3610		'̕
'Zq̂Ƃ(VZqopɕۑ㤋ZqŉZ)
:L36140
	CALL	:L361Z0		'LR=LR op RR
	LDX	:OP,@:PTR	'VZqopɕۑ
	JP	:L3610		'̕
'"("̂Ƃ
:L36150
	LDWX	:LR2,:LR	'LR,OPޔ
	LD	:OP2,:OP
	CLR	:LR		'ڼ޽(LR=0)
	CLR	:LRL
	CLR	:RR		'Eڼ޽(RR=0)
	CLR	:RRL
	LD	:OP,#:CH_PLS	'Zq(OP="+")
	JP	:L3610
'")"̂Ƃ
:L36160
	CALL	:L361Z0		'RR=LR op RR
	LDWX	:RR,:LR
	LDWX	:LR,:LR2	'LR,OP𕜋A
	LD	:OP,:OP2
	CP	:ARYF,#1
	JP	/NE,:L3610	'ʏ튇ʂ̂Ƃ̕
'(z")"Ƃ)
	LDWX	0,:RR		'RR=@(RR)
	CALL	:CALAA
	LDX	:RR,@2
	INCW	2
	LDX	:RRL,@2
	CLR	:ARYF		'ARYF=0(z񊇌ʂI)
	JP	:L3610		'̕
'"@"̂Ƃ
:L36170
	LD	:ARYF,#1	'ARYF=1(̉Eʂ͔z񱸾)
	JP	:L3610		'̕
'"?"̂Ƃ
:L36180
	CALL	:INPNN		'10iN
	LDWX	:RR,0
	JP	:L3610		'̕
'̑̂Ƃ
:L36190
	JP	:L3610		'̕
'Zٰ(RR=LR op RR,RR=0)
:L361Z0
	LDWX	8,:LR		'ʉŽٰ݂ďo
	LDWX	10,:RR
'(ỎZq)
	CP	:OP,#:CH_PLS	'"+"
	JP	/EQ,:L361Z1
	CP	:OP,#:CH_MIN	'"-"
	JP	/EQ,:L361Z2
	CP	:OP,#:CH_AST	'"*"
	JP	/EQ,:L361Z3
	CP	:OP,#:CH_SLS	'"/"
	JP	/EQ,:L361Z4
	CP	:OP,#:CH_LT	'"<"
	JP	/EQ,:L361Z5
	CP	:OP,#:CH_EQ	'"="
	JP	/EQ,:L361Z6
	CP	:OP,#:CH_GT	'">"
	JP	/EQ,:L361Z7
'("+"̂Ƃ)
:L361Z1
	CALL	:ADDW		'LR=LR+RR
:L361Z9
	LDWX	:LR,12
	CLR	:RR		'RR=0
	CLR	:RRL
	RET
'("-"̂Ƃ)
:L361Z2
	CALL	:SUBW		'LR=LR-RR
	JP	:L361Z9
'("*"̂Ƃ)
:L361Z3
	CALL	:MULW		'LR=LR*RR
	JP	:L361Z9
'("/"̂Ƃ)
:L361Z4
	CALL	:DIVW		'LR=LR/RR
	LDWX	:LR,14
	LDWX	:MOD,12		'%=Z̗](p)
	CLR	:RR		'RR=0
	CLR	:RRL
	RET
'("<"̂Ƃ)
:L361Z5
	CALL	:LTW		'LR=LR<RR
	JP	:L361Z9
'("="̂Ƃ)
:L361Z6
	CALL	:EQW		'LR=LR=RR
	JP	:L361Z9
'(">"̂Ƃ)
:L361Z7
	CALL	:GTW		'LR=LR>RR
	JP	:L361Z9
'----------------------------------------------------------------
'No.362 SRLN
'----------------------------------------------------------------
':sԍ
'@\:wsԍƓŏ̍s擪
':޲؎wsԍ(RR0)
'o:ŏ̍s擪ڽ(RR0)v(C=1)A/۸і(C=0)Aƕϐ(R2,RR8,RR10,RR12)
'----------------------------------------------------------------
:SRLN
	LDWX	8,:TOP		'߲(RR8)=۸ѐ擪(*)
'۸яI
:L3620
	CP	8,:EOP		'۸ѐ擪(&)ƈv?
	JR	/NE,:L3621
	CP	9,:EOPL   
	JR	/NE,:L3621
'۸і/vȂ۸іɒBƂ
	LDWX	0,8		'RR0=۸ѐ擪(&)
	RCF			'C=0(۸і/vȂ۸іɒBƂ)
	RET
'wsԍƓ?
:L3621
	CALL	:VALNN		'wڽ(RR8)10i޲ؐl(RR10)
	CP	r10,r0		'wsԍƓ?(޲Ăr)
	JR	/NE,:L3622
	CP	r11,r1		'޲ĂŉȂߤ޲Ăr
:L3622
	JR	/EQ,:L3624	'ƂI
	JR	/NC,:L3625	'ƂI
'ǂłȂƂ߲̍s֍XV
:L3623
	INCW	8		'CR܂߲XV
	LDX	2,@8
	CP	2,#:CH_CR
	JR	/NZ,:L3623
	INCW	8		'߲+1
	JR	:L3620		'߂
'I
:L3624
	LDWX	0,8		'RR0=݂߲ws
	SCF			'C=1(vƂ)
	RET
:L3625
	LDWX	0,8		'RR0=݂߲ws
	RCF			'C=0(Ƃ)
	RET
'----------------------------------------------------------------
'No.363 CALVA
'----------------------------------------------------------------
':ϐڽvZ
'@\:wϐڽvZ
':ϐ(R0)
'o:ϐ̎ڽ(RR2)
'----------------------------------------------------------------
:CALVA
	CP	0,#:CH_EXC	'"!"
	JR	/EQ,:L3630
	CP	0,#:CH_NUM	'"#"
	JR	/EQ,:L3631
	CP	0,#:CH_AMP	'"&"
	JR	/EQ,:L3632
	CP	0,#:CH_COL	'":"
	JR	/EQ,:L3633
	CP	0,#:CH_PER	'"%"
	JR	/EQ,:L3634
	CP	0,#:CH_A	'IF A?
	JR	/C,:L3635
	CP	0,#:CH_Z	'IF Z?
	JR	/ULE,:L3636
	JR	:L3635		'̑
'"!"̂Ƃ
:L3630
	LD	r2,#0		'RR2=ϐ"!"ڽ
	LD	r3,#:RLN
	RET
'"#"̂Ƃ
:L3631
	LD	r2,#0		'RR2=ϐ"#"ڽ
	LD	r3,#:XLN
	RET
'"&"̂Ƃ
:L3632
	LD	r2,#0		'RR2=ϐ"&"ڽ
	LD	r3,#:EOP
	RET
'":"̂Ƃ
:L3633
	LD	r2,#0		'RR2=ϐ":"ڽ
	LD	r3,#:EOM
	RET
'"%"̂Ƃ
:L3634
	LD	r2,#0		'RR2=ϐ"%"ڽ
	LD	r3,#:MOD
	RET
'аϐ̂Ƃ
:L3635
	LD	r2,#0		'RR2=аϐڽ
	LD	r3,#:OTH
	RET
'ʏϐ(A-Z)̂Ƃ
:L3636
	SUB	0,#:CH_A	'RR2=ϐ"A"ڽ+(ϐ-'A')*2
	RCF
	RLC	0
	CLR	2
	LD	r3,#:VA
	ADD	3,0
	ADC	2,#0
	RET
'----------------------------------------------------------------
'No.364 CALAA
'----------------------------------------------------------------
':zڽvZ
'@\:z̎ڽvZ
':z޲؈(RR0)
'o:ϐ̎ڽ(RR2)
'----------------------------------------------------------------
:CALAA
	LDWX	2,0		'RR2=RR0*2+z擪ڽ(*)
	RCF
	RLC	3
	RLC	2
	ADD	3,:EOML
	ADC	2,:EOM
	RET
'----------------------------------------------------------------
'No.365 INPNN
'----------------------------------------------------------------
':
'@\:[u1s(CR܂)Aƕϐ(r0,r1)
':[u
'o:ް(:NBUF`)͐l(RR0)
'----------------------------------------------------------------
:INPNN
'
	LD	r1,#0		'sޯ̧=0
:L3650
	CALL	:INPCH		'1
	CALL	:OUTCHX		'ޯ
	CP	0,#:CH_BS	'BS?
	JR	/EQ,:L3651
	LD	:NBUF,r1,r0	'ޯ̧ɕۑ
	INC	r1		'ނ+1
	CP	0,#:CH_CR	'CR?
	JR	/NZ,:L3650
'/lϊ
	CLR	8		'RR8=ޯ̧擪ڽ
	LD	9,#:NBUF
	CALL	:VALNN		'ϊ
	LDWX	0,10
	RET
:L3651
	CP	1,#0		'BS\?
	JR	/EQ,:L3650
	DEC	1		'ނ-1
	JR	:L3650
